#include "TaskManager.h"

TaskBase::TaskBase(TaskManager *argList) : manager(NULL), enableFlag(true)
{
	if(argList != NULL) {
		argList->entry(this);
	}

	return;
}

TaskBase::~TaskBase()
{
	if(manager != NULL) {
		manager->remove(this);
	}

	return;
}

void TaskBase::enable(void)
{
	enableFlag = true;
}

void TaskBase::disable(void)
{
	enableFlag = false;
}

bool TaskBase::isEnabled(void)
{
	return enableFlag;
}


TaskManager::TaskManager(void)
{
}

TaskManager::~TaskManager(void)
{
	clear();
}

void TaskManager::update(void)
{
	list<TaskBase*>::iterator it;

	for(it = taskList.begin(); it != taskList.end(); ++it) {
		if((*it)->enableFlag) {
			(*it)->update();
		}
	}

	return;
}

void TaskManager::entry(TaskBase *argTask)
{
	remove(argTask);
	taskList.push_back(argTask);
	argTask->manager = this;

	return;
}

void TaskManager::remove(TaskBase *argTask)
{
	list<TaskBase*>::iterator it;

	for(it = taskList.begin(); it != taskList.end(); ++it) {
		if((*it) == argTask) {
			argTask->manager = NULL;
			taskList.erase(it);
			break;
		}
	}

	return;
}

void TaskManager::clear(void)
{
	list<TaskBase*>::iterator it;

	for(it = taskList.begin(); it != taskList.end(); ++it) {
		(*it)->manager = NULL;
	}
	taskList.clear();

	return;
}

bool TaskManager::isEntried(TaskBase *argTask)
{
	list<TaskBase*>::iterator it;

	for(it = taskList.begin(); it != taskList.end(); ++it) {
		if((*it) == argTask) {
			return true;
		}
	}

	return false;
}

void TaskManager::toTop(TaskBase *argTask)
{
	remove(argTask);
	taskList.push_front(argTask);
	argTask->manager = this;

	return;
}

void TaskManager::toBottom(TaskBase *argTask)
{
	entry(argTask);

	return;
}
